import matplotlib.pyplot as plt
import matplotlib.collections
import matplotlib.patches
import numpy as np


def errorband(p, ax=None, underflow=False, overflow=False):
    if ax is None:
        ax = plt.gca()

    p = p.copy()

    delta = p[2,0] - p[1,0]

    if p[0,0] == -np.inf:
        if underflow is False:
            p = p[1:]
        else:
            s = 2 if type(underflow) == bool else underflow
            p[0,0] = p[1,0] - (s+0.5) * delta
    if p[-1,0] == +np.inf:
        if overflow is False:
            p = p[:-1]
        else:
            s = 2 if type(overflow) == bool else overflow
            p[-1,0] = p[-2,0] + (s+0.5) * delta

    boxes = [
        matplotlib.patches.Rectangle(
            (x - delta, y - e/2), delta, e
        )
        for x, y, e in p
    ]

    artist = ax.step(p[:,0], p[:,1])
    col = artist[0].get_color()

    pc = matplotlib.collections.PatchCollection(
        boxes,
        facecolor=col, edgecolor=col
    )

    ax.add_collection(pc)
    return artist
